package com.cttic.tcpreceive.client;

import com.cttic.tcpreceive.conf.SpringContextUtil;
import com.cttic.tcpreceive.init.MyClient;
import com.cttic.tcpreceive.rocket.RocketProducer;
import com.cttic.tcpreceive.service.TcpTest;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import io.netty.util.ReferenceCountUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Component;


@Slf4j
@Component
@Lazy
public class MyClientHandler extends SimpleChannelInboundHandler<String> {

  private static MyClient myClient;
  private static TcpTest tcpTest;
  private static RocketProducer producer;

  static {
    myClient = SpringContextUtil.getBean(MyClient.class);
    tcpTest = SpringContextUtil.getBean(TcpTest.class);
    producer = SpringContextUtil.getBean(RocketProducer.class);
  }

  @Override
  public void channelActive(ChannelHandlerContext ctx) throws Exception {

  }

  @Override
  protected void channelRead0(ChannelHandlerContext ctx, String msg) throws Exception {
//    System.out.println(msg);
    try {
      String buf = (String) msg;
      log.info("接收到消息:{}",buf);
      String lastEnd = "";
      producer.sendMessageAsync("ais",buf);
//      tcpTest.analysis(lastEnd,buf);
    }catch (Exception e) {
      log.info("出错:{}...但是继续执行",e.getMessage());
    }finally {
      ReferenceCountUtil.release(msg);
    }
  }

  @Override
  public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
    cause.printStackTrace();
    ctx.close();
  }

  @Override
  public void handlerRemoved(ChannelHandlerContext ctx) throws Exception {
    MyClient.CONNECT_STATUS = Boolean.FALSE;
    log.error("，当前被移除的channel的短ID是：" + ctx.channel().id().asShortText());
    super.handlerRemoved(ctx);
  }
}
