package com.cttic.tcpreceive.client;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.LengthFieldBasedFrameDecoder;

 
public class MyMessageDecoder extends LengthFieldBasedFrameDecoder {

    int length = 0;

    public MyMessageDecoder(int maxFrameLength, int lengthFieldOffset, int lengthFieldLength) {
        super(maxFrameLength, lengthFieldOffset, lengthFieldLength);
    }

    @Override
    protected String decode(ChannelHandlerContext ctx, ByteBuf in) {
        if (in.readableBytes() >= 5) {
            byte[] content;
            if (length == 0) {
                length = in.readInt();
            }
            if (in.readableBytes() < length) {
                return null;
            }
            content = new byte[length];
            if (in.readableBytes() >= length) {
                in.readBytes(content);
            }
            length = 0;
            return new String(content);
        }

        return null;
    }
}
